using System;

namespace Example1
{
    /// <summary>
    /// Simple program that verifies if a valid SmartDongle is plugged in.
    ///
    /// MicroWorks, Inc.
    /// 2808 North Cole Road
    /// Boise, ID 83704
    ///
    /// http://www.smartdongle.com
    ///
    /// </summary>
    class Example1
    {
        [STAThread]

        static void Main()
        {
            UInt64 P1, P2;
            SmartDongle.SmartDnglError error;
            System.Text.ASCIIEncoding  encoding = new System.Text.ASCIIEncoding();


            /* Your keys here */
            P1=0xec6cc589aefd1e75;
            P2=0xfcec0a6a82747b3f;

            /* Simply check for presence of valid SmartDongle.  */
            error = SmartDongle.Read(P1, P2, 0, new byte[0], 0);
            if (error != SmartDongle.SmartDnglError.UskOk)
            {
                System.Console.WriteLine(SmartDongle.GetErrorString(error));

                // handle error
            }
            else
            {
                System.Console.WriteLine("Success: Valid SmartDongle Found\n");
            }

            System.Console.WriteLine("Press <Enter> to Exit");
            System.Console.ReadLine();
        }
    }
}

