using System;
using System.Text;
using System.IO;

namespace Example
{
    /// <summary>
    ///  Write some misc application data to a SmartDongle.
    ///
    /// MicroWorks, Inc.
    /// 2808 North Cole Road
    /// Boise, ID 83704
    ///
    /// http://www.smartdongle.com
    ///
    /// </summary>
    class Example2a
    {
        [STAThread]

        static void Main(string[] args)
        {
            UInt64 P1, P2;
            SmartDongle.SmartDnglError error;
            System.Text.ASCIIEncoding  encoding = new System.Text.ASCIIEncoding();

            /* Some application data */
            const string yourData = "This is data written to the SmartDongle, it can be serial numbers, program parameters, etc.  Note that this data can be read by observing activity on the USB bus. Refer to Example3a.cs and Example3b.cs for example of encrypting your application data.";

            /* Your SmartDongle keys go here */
            P1 = 0xec6cc589aefd1e75;
            P2 = 0xfcec0a6a82747b3f;
            /*
            *  Write a your data to SmartDongle.
            *  Note: The number of writes is limited, SmartDongle uses a Catalyst
            *  CAT25C256 SPI eprom, which has a life expectancy of approximately
            *  1 Million write cycles.  Reads are unlimited.
            */
            UInt16 address = 0;
            byte[] plainText = Encoding.UTF8.GetBytes(yourData);

            System.Console.WriteLine("Size of byte array: "+plainText.Length);
            
            error = SmartDongle.Write(P1, P2, address, plainText, plainText.Length);
            if (error == SmartDongle.SmartDnglError.UskOk)
            {
                System.Console.WriteLine("Success: Wrote application data to SmartDongle\n");
            }
            else
            {
                System.Console.WriteLine(SmartDongle.GetErrorString(error));
                System.Console.WriteLine("Failed: Could not write application data to SmartDongle\n");
            }

            System.Console.WriteLine("Press <Enter> to Exit");
            System.Console.ReadLine();
        }
    }
}

