using System;
using System.Security.Cryptography;
using System.Text;
using System.IO;

namespace Example
{
    /// <summary>
    /// Example2b.cs: Read application data written to SmartDongle in Example2a.cs
    ///
    /// MicroWorks, Inc.
    /// 2808 North Cole Road
    /// Boise, ID 83704
    ///
    /// http://www.smartdongle.com
    ///
    /// </summary>
    class Example2b
    {
        [STAThread]

        static void Main(string[] args)
        {
            UInt64 P1, P2;
            UInt16 address = 0;
            SmartDongle.SmartDnglError error;
            System.Text.ASCIIEncoding encoding = new System.Text.ASCIIEncoding();

            /* This is the application data you are looking for from Example 2A */
            const string yourData = "This is data written to the SmartDongle, it can be serial numbers, program parameters, etc.  Note that this data can be read by observing activity on the USB bus. Refer to Example3a.cs and Example3b.cs for example of encrypting your application data.";

            /* Your SmartDongle keys here */
            P1 = 0xec6cc589aefd1e75;
            P2 = 0xfcec0a6a82747b3f;

            /*
             *  Read a byte array from the SmartDongle with the expected length of your data
             */
            byte[] datum = Encoding.UTF8.GetBytes(yourData);
            byte[] inBuffer = new byte[yourData.Length];

            error = SmartDongle.Read(P1, P2, address, inBuffer, yourData.Length);
            if (error != SmartDongle.SmartDnglError.UskOk) {

                System.Console.WriteLine(SmartDongle.GetErrorString(error));
                return;
            }

            /*
             *  As an exercise, simply comparing data read from SmartDongle to
             *  the expected user data.  A developer could do any number of things
             *  with the data read here.
             */
            int i;
            for (i = 0; (i < datum.Length) && (datum[i] == inBuffer[i]); i++) ;
            if (i == datum.Length)
            {
                System.Console.WriteLine("Success: Found Valid Application Data\n");
            }
            else
            {
                System.Console.WriteLine("Failed: Invalid Application Data\n");
            }

            System.Console.WriteLine("Press <Enter> to Exit");
            System.Console.ReadLine();
        }
    }
}

